;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill shooter - Standard version
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; Generated sprite's extra bit will be set same value as this shooter.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!CustSprite =		$12		; Set to be generated sprite number
		!GenTimer =		$60		; Set interval for generate
		
		!SE_Shot_SFX =		$09		;\ Choose Shot SFX
		!SE_Shot_RAM =		$1DFC		;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!RAM_BackwardDistL =	$1534
		!RAM_BackwardDistH =	$1528
		!RAM_AngleL =		$1504
		!RAM_AngleH =		$151C

		!RAM_ExtraBits =	$7FAB10
		!RAM_NewSpriteNum =	$7FAB9E
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	LDA $17AB,x
		BNE .Return
		LDA.b #!GenTimer
		STA $17AB,x
		LDA $178B,x
		CMP $1C
		LDA $1793,x
		SBC $1D
		BNE .Return
		LDA $17A3,x
		XBA
		LDA $179B,x
		REP #$21
		ADC.w #$0010
		SEC
		SBC $1A
		CMP.w #$0120
		SEP #$20
		BCS .Return
		LDA $94
		ADC #$11
		SEC
		SBC $179B,x
		CMP #$22
		BCC .Return
		JSL $82A9DE
		BPL +
.Return		RTS

+		LDA #$88
		BIT $1783,x
		BVC +
		ORA #$04
+		STA $02
		TYX
		LDA.b #!CustSprite
		STA !RAM_NewSpriteNum,x
		JSL $87F7D2
		LDA $02
		STA !RAM_ExtraBits,x
		LDA #$01
		STA !RAM_BackwardDistH,x
		LDA #$80
		STA !RAM_BackwardDistL,x
		LDA #$01
		STA $14C8,x
		LDA.b #!SE_Shot_SFX
		STA.w !SE_Shot_RAM
		
		TXY
		LDX $15E9
		
		LDA $179B,x
		STA $00E4,y
		LDA $17A3,x
		STA $14E0,y
		LDA $178B,x
		SEC
		SBC #$01
		STA $00D8,y
		LDA $1793,x
		SBC #$00
		STA $14D4,y
		
		LDA $94
		CMP $179B,x
		LDA $95
		SBC $17A3,x
		ASL A
		LDA #$00
		ROL A
		STA !RAM_AngleH,y
		TAY

GenSmoke:	LDA .XofsL,y
		STA $00
		CLC
		ADC $179B,x
		STA $01
		LDA .XofsH,y
		ADC $17A3,x
		LDY $01
		CPY $1A
		SBC $1B
		BNE .Return
		LDA $178B,x
		CMP $1C
		LDA $1793,x
		SBC $1D
		BNE .Return

		LDY #$03
.FindFree	LDA $17C0,y
		BEQ .FoundFree
		DEY
		BPL .FindFree
.Return		RTS

.FoundFree	LDA #$01
		STA $17C0,y
		LDA $178B,x
		STA $17C4,y
		LDA #$1B
		STA $17CC,y
		LDA $179B,x
		CLC
		ADC $00
		STA $17C8,y
		RTS
		
.XofsL		db $08,$F8
.XofsH		db $00,$FF
