;@sa1 <-- DO NOT REMOVE THIS LINE!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill shooter - Standard version
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; Generated sprite's extra bit will be set same value as this shooter.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!CustSprite =		$12		; Set to be generated sprite number
		!GenTimer =		$60		; Set interval for generate
		
		!SE_Shot_SFX =		$09		;\ Choose Shot SFX
		!SE_Shot_RAM =		$1DFC		;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; SA-1 pack - Memory remap
		!BW =		$6000
		
		!9E =		$3200
		!AA =		$9E
		!B6 =		$B6
		!C2 =		$D8
		!D8 =		$3216
		!E4 =		$322C

		!00AA =		$309E
		!00B6 =		$30B6
		!00C2 =		$30D8
		!009E =		$3200
		!00D8 =		$3216
		!00E4 =		$322C
		!14C8 =		$3242
		!14D4 =		$3258
		!14E0 =		$326E
		!151C =		$3284
		!1528 =		$329A
		!1534 =		$32B0
		!1540 =		$32C6
		!154C =		$32DC
		!1558 =		$32F2
		!1564 =		$3308
		!1570 =		$331E
		!157C =		$3334
		!1588 =		$334A
		!1594 =		$3360
		!15A0 =		$3376
		!15AC =		$338C
		!15EA =		$33A2
		!15F6 =		$33B8
		!1602 =		$33CE
		!160E =		$33E4
		!163E =		$33FA
		!187B =		$3410
		
		!14EC =		$74C8
		!14F8 =		$74DE
		!1504 =		$74F4
		!1510 =		$750A
		!15B8 =		$7520
		!15C4 =		$7536
		!15D0 =		$754C
		!15DC =		$7562
		!161A =		$7578
		!1626 =		$758E
		!1632 =		$75A4
		!190F =		$7658
		!1FD6 =		$766E
		!1FE2 =		$7FD6
		!164A =		$75BA
		!1656 =		$75D0
		!1662 =		$75EA
		!166E =		$7600
		!167A =		$7616
		!1686 =		$762C
		!186C =		$7642
		
		!RAM_BackwardDistL =	!1534
		!RAM_BackwardDistH =	!1528
		!RAM_AngleL =		!1504
		!RAM_AngleH =		!151C

		!RAM_ExtraBits =	$6040
		!RAM_NewSpriteNum =	$6083
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	LDA.w $17AB|!BW,x
		BNE .Return
		LDA.b #!GenTimer
		STA.w $17AB|!BW,x
		LDA.w $178B|!BW,x
		CMP $1C
		LDA.w $1793|!BW,x
		SBC $1D
		BNE .Return
		LDA.w $17A3|!BW,x
		XBA
		LDA.w $179B|!BW,x
		REP #$21
		ADC.w #$0010
		SEC
		SBC $1A
		CMP.w #$0120
		SEP #$20
		BCS .Return
		LDA $94
		ADC #$11
		SEC
		SBC.w $179B|!BW,x
		CMP #$22
		BCC .Return
		JSL $02A9DE
		BPL +
.Return		RTS

+		LDA #$88
		BIT.w $1783|!BW,x
		BVC +
		ORA #$04
+		STA $02
		TYX
		LDA.b #!CustSprite
		STA !RAM_NewSpriteNum,x
		JSL $07F7D2
		LDA $02
		STA !RAM_ExtraBits,x
		LDA #$01
		STA !RAM_BackwardDistH,x
		LDA #$80
		STA !RAM_BackwardDistL,x
		LDA #$01
		STA !14C8,x
		LDA.b #!SE_Shot_SFX
		STA.w !SE_Shot_RAM|!BW
		
		TXY
		LDX.w $15E9|!BW
		
		LDA.w $179B|!BW,x
		STA !00E4,y
		LDA.w $17A3|!BW,x
		STA !14E0,y
		LDA.w $178B|!BW,x
		SEC
		SBC #$01
		STA !00D8,y
		LDA.w $1793|!BW,x
		SBC #$00
		STA !14D4,y
		
		LDA $94
		CMP.w $179B|!BW,x
		LDA $95
		SBC.w $17A3|!BW,x
		ASL A
		LDA #$00
		ROL A
		STA !RAM_AngleH,y
		TAY

GenSmoke:	LDA .XofsL,y
		STA $00
		CLC
		ADC.w $179B|!BW,x
		STA $01
		LDA .XofsH,y
		ADC.w $17A3|!BW,x
		LDY $01
		CPY $1A
		SBC $1B
		BNE .Return
		LDA.w $178B|!BW,x
		CMP $1C
		LDA.w $1793|!BW,x
		SBC $1D
		BNE .Return

		LDY #$03
.FindFree	LDA.w $17C0|!BW,y
		BEQ .FoundFree
		DEY
		BPL .FindFree
.Return		RTS

.FoundFree	LDA #$01
		STA.w $17C0|!BW,y
		LDA.w $178B|!BW,x
		STA.w $17C4|!BW,y
		LDA #$1B
		STA.w $17CC|!BW,y
		LDA.w $179B|!BW,x
		CLC
		ADC $00
		STA.w $17C8|!BW,y
		RTS
		
.XofsL		db $08,$F8
.XofsH		db $00,$FF
